import React from 'react';
import { withKnobs, select, text, boolean } from '@storybook/addon-knobs';
import ButtonGroup from '../ButtonGroup';
import OverflowMenuItem from '../OverflowMenuItem';
var kinds = {
  'Primary button (primary)': 'primary',
  'Secondary button (secondary)': 'secondary',
  'Danger button (danger)': 'danger',
  'Ghost button (ghost)': 'ghost'
};
var sizes = {
  Default: 'default',
  Field: 'field',
  Small: 'small'
};
var props = {
  regular: function regular() {
    return {
      buttonLabel: text('Button Label', 'Button Label'),
      size: select('Button size (size)', sizes, 'default'),
      kind: select('Button kind (kind)', kinds, 'primary'),
      disabled: boolean('Disabled (disabled)', false)
    };
  }
};
export default {
  title: 'RocketPatterns/ButtonGroup',
  decorators: [withKnobs],
  parameters: {
    component: ButtonGroup
  }
};
export var _Default = function _Default() {
  return /*#__PURE__*/React.createElement(ButtonGroup, props.regular(), /*#__PURE__*/React.createElement(OverflowMenuItem, {
    primaryFocus: true,
    itemText: 'Item 1'
  }), /*#__PURE__*/React.createElement(OverflowMenuItem, {
    itemText: 'Item 2'
  }), /*#__PURE__*/React.createElement(OverflowMenuItem, {
    itemText: 'Item 3'
  }));
};